/* ClientSocket.h

java-like implementation of sockets.

Part of the caiviar package. 

Copyright (c) 2002 MobileX AG, http://www.mobilexag.de
Copyright (c) 2002 Peter Dikant <peter.dikant@mobilexag.de>

This file is distributed under the GPL, see file COPYING for details. */

#ifndef __clientsocket_h__
#define __clientsocket_h__

#include "../config.h"

#if defined(WIN32)
#ifndef __windows_h_included__
#define __windows_h_included__
#include <windows.h>
#endif
#elif defined(CYGWIN) || defined(LINUX)
typedef int SOCKET;
const int SOCKET_ERROR = -1;
const int INVALID_SOCKET = -1;
#endif

class ServerSocket;

class ClientSocket  
{
	friend class ServerSocket;
public:
	bool establishConnection();
	ClientSocket(SOCKET client);
	ClientSocket(const char *host, int port);
	virtual ~ClientSocket();
	int print(const char* line);
	int myprintf(const char *line, ...);
	int readLine (char* buffer, int bufferSize);
	int readLine (char* buffer);
	int isAlive();
	char* getHost() {return host;};
	int getBlock(char *buffer, int size);
	int getFileDescriptor() {return client;};
private:
	char* host;
	int port;
	SOCKET client;
};

#endif //__clientsocket_h__
