/* RealSpeak.h

Header file for RealSpeak.cpp

Part of the caiviar package. 

Copyright (c) 2002 MobileX AG, http://www.mobilexag.de
Copyright (c) 2002 Peter Dikant <peter.dikant@mobilexag.de>

This file is distributed under the GPL, see file COPYING for details. */

#include "../src/Log.h"

#ifndef __festival_h__
#define __festival_h__

#define TTS_OUTPUT_BUFFER 1048576 // 1 MByte output buffer

class Festival: public TextToSpeech
{
public:
	static int initialize(Logger*log);
	static void finalize(Logger*log);

	virtual void text2Stream (const char *text, unsigned char **outbuffer, unsigned long *size);
	virtual void text2File (const char *text, const char *filename);
	virtual void text2Audio (const char *text);
	virtual void setParams (const char *key, const char* value);
	Festival(Logger *log);
	virtual ~Festival();
private:
	static int instances;
};

#endif
