/* TextToSpeech.h

Generic interface for TTS implementations.

Part of the caiviar package. 

Copyright (c) 2002 MobileX AG, http://www.mobilexag.de
Copyright (c) 2002 Matthias Kramm <kramm@mobilexag.de>

This file is distributed under the GPL, see file COPYING for details. */

#ifndef __text2speech__
#define __text2speech__

#include "../config.h"
#include "../src/Log.h"

class TextToSpeech
{
public:
	static int initialize(Logger*log);
	static void finalize(Logger*log);

	static TextToSpeech* getImplementation(Logger * log);
	
	virtual void setParams (const char *key, const char*value);
	virtual void text2Stream (const char *text, unsigned char **outbuffer, unsigned long *size);
	virtual void text2File (const char *text, const char *filename);
	virtual void text2Audio (const char *text);
	TextToSpeech(Logger *log);
	virtual ~TextToSpeech();
protected:
	Logger * log;
};

#endif
