/* Log.h

Header for Log.cpp

Part of the caiviar package. 

Copyright (c) 2002 MobileX AG, http://www.mobilexag.de
Copyright (c) 2002 Matthias Kramm <kramm@quiss.org>

This file is distributed under the GPL, see file COPYING for details. */

#ifndef __Log_h__
#define __Log_h__

#define LOGLEVEL_FATAL 0
#define LOGLEVEL_ERROR 1
#define LOGLEVEL_WARNING 2
#define LOGLEVEL_NOTICE 3
#define LOGLEVEL_VERBOSE 4
#define LOGLEVEL_DEBUG 5
#define LOGLEVEL_TRACE 6

class Logger {
public:
    ~Logger();
    void log(char* logString);
    void logf(const char* logFormat, ...);
    Logger(int screenloglevel);
    Logger();

    void setScreenLogging(int screenloglevel);
    void setFileLogging(char* filename, int fileloglevel);
    void setSocketLogging(char* host, char* port, int socketloglevel);
    void initLog(char* filename, int fileloglevel, char* servAddr, char* logPort, int serverloglevel, int screenloglevel);

private:
    void*internal;
};


#endif // __Log_h__
