/* wav.h
   Header file for wav.c

   Part of the caiviar package.
   
   Copyright (c) 2001 Matthias Kramm <kramm@quiss.org>

   This file is distributed under the GPL, see file COPYING for details */

#ifndef __wav_h__
#define __wav_h__

struct WAV {
    unsigned short      tag;
    unsigned short      channels;
    unsigned long       sampsPerSec;
    unsigned long       bytesPerSec;
    unsigned short      align;
    unsigned short      bps;
    
    unsigned char*data;
    unsigned int size;
};

int readWAV(char* filename, struct WAV*wav);
int writeWAV(char* filename, struct WAV*wav);
int readWAVFromMem(void*data, int len, struct WAV*wav);

void printWAVInfo(struct WAV*wav);
int convertWAV2mono(struct WAV*src, struct WAV*dest, int rate);

void convertWAV2LAW(struct WAV*src, unsigned char**data, int*size);
void convertLAW2WAV(void*data, int size, struct WAV*src);

/* mix together two law blocks */
void mix_law(unsigned char*src1, unsigned char*src2, unsigned char*dest, int len);

// for convenience
unsigned char*wav2law(unsigned char*wavedata, int len, int *len2);

#endif
